"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _qs = require("qs");

var _qs2 = _interopRequireDefault(_qs);

var _url = require("url");

var _url2 = _interopRequireDefault(_url);

var ServerLocation = (function () {
  function ServerLocation(_ref, redirect) {
    var req = _ref.req;
    var request = _ref.request;
    var reply = _ref.reply;
    var res = _ref.res;

    _classCallCheck(this, ServerLocation);

    if (req) {
      // Express
      this.path = _url2["default"].format({
        pathname: req.path,
        search: _qs2["default"].stringify(_extends({}, req.query, req.body, {
          _headers: req.headers,
          _method: req.method.toUpperCase()
        }))
      });

      this.redirect = redirect || res.redirect.bind(res);
    } else if (request) {
      // Hapi
      this.path = _url2["default"].format({
        pathname: request.url.pathname,
        search: _qs2["default"].stringify(_extends({}, request.query, request.payload, {
          _headers: request.headers,
          _method: request.method.toUpperCase()
        }))
      });

      this.redirect = redirect || reply.redirect.bind(reply);
    } else {
      throw new Error("ServerLocation.constructor requires `req` or `request` key");
    }
  }

  _createClass(ServerLocation, [{
    key: "getCurrentPath",
    value: function getCurrentPath() {
      return this.path;
    }
  }, {
    key: "pop",
    value: function pop() {
      throw new Error("<ServerLocation> does not support pop()");
    }
  }, {
    key: "push",
    value: function push(path) {
      this.redirect(path);
    }
  }, {
    key: "replace",
    value: function replace(path) {
      this.redirect(path);
    }
  }, {
    key: "toString",
    value: function toString() {
      return "<ServerLocation path=\"" + this.getCurrentPath() + "\">";
    }
  }, {
    key: "needsDOM",
    get: function get() {
      return false;
    }
  }]);

  return ServerLocation;
})();

exports["default"] = ServerLocation;
module.exports = exports["default"];